<!--
/**
 * ----------------------------------------------------------------
 * @Author     : Mathieu Boutin
 *
 * @File       : Tooltip.vue
 * @Created_at : 26/03/2022
 * @Update_at  : 26/03/2022
 * ----------------------------------------------------------------
 */
-->

<style type="text/css" src="./css/Tooltip.css" scoped></style>

<script>
    import ObjectManager from "../service/Manager/ObjectManager";
    import TypeManager from "../service/Manager/TypeManager";
    import TriggerConstant from "../service/Constant/TriggerConstant";

    export default {
        name: "Tooltip",

        components: {},

        props: {
            options: {
                type: Object,
                default: () => {
                    return {};
                }
            }
        },

        data: () => {
            return {
                style: null
            }
        },

        watch: {
            options: {
                handler: function (newOptions) {
                    this.prepareStyle(newOptions);
                }
            }
        },

        // Life Cycle : Created
        created() {
            this.prepareStyle(this.options);
        },

        // Life Cycle : Before destroy
        beforeDestroy() {
            // Destroy style
            this.style = null;
        },

        methods: {
            // --------------------------------
            // Prepare

            /**
             * Prepare style.
             *
             * @param options
             */
            prepareStyle(options) {
                // ----------------
                // Vars

                // Width
                let width = ObjectManager.get(options, 'width');
                let widthMin = ObjectManager.get(width, 'min');
                let widthMax = ObjectManager.get(width, 'max');

                // Position
                let position = ObjectManager.get(options, 'position');
                let top = ObjectManager.get(position, 'top');
                let left = ObjectManager.get(position, 'left');

                // Trigger
                let trigger =  ObjectManager.get(options,'trigger');

                // ----------------
                // Process

                let style = ``;

                if (!TypeManager.isNull(widthMin)) {
                    style += `min-width: ${widthMin}px;`;
                }
                if (!TypeManager.isNull(widthMax)) {
                    style += `max-width : ${widthMax}px;`;
                }

                if (!TypeManager.isNull(top)) {
                    style += `top: ${top}px;`;
                }
                if (!TypeManager.isNull(left)) {
                    style += `left : ${left}px;`;
                }

                // Add margin if focus (top and left are null).
                if(trigger === TriggerConstant.FOCUS){
                    style += 'margin: 5px';
                }

                this.style = style;
            },

            // --------------------------------
            // Event

            /**
             * Event on : Mouse enter.
             *
             * @param event
             */
            mouseEnterEvent(event) {
                this.$emit('mouseenter', event);
            },

            /**
             * Event on : Mouse enter.
             *
             * @param event
             */
            mouseLeaveEvent(event) {
                this.$emit('mouseleave', event);
            },

            /**
             * Event on : Focus.
             *
             * @param event
             */
            focusEvent(event) {
                console.log("focus ")
                this.$emit('focus', event);
            },

            /**
             * Event on : Blur.
             *
             * @param event
             */
            blurEvent(event) {
                this.$emit('blur', event);
            }
        }
    }
</script>

<template>
    <div
        class="tooltip"
        :style="style"

        @mouseenter="mouseEnterEvent"
        @mouseleave="mouseLeaveEvent"
        @focus="focusEvent"
        @blur="blurEvent"
    >
        <slot name="Tooltip"></slot>
    </div>
</template>
